#include <mega32.h>
#include <stdio.h>
#include <stdlib.h>
#include "2.h" 
#include "8255_motor.h" 
#include <delay.h>
#include "gcdbinunit.h"
#include <math.h>

// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{     
     tmp=0;
     
     if((x1==x)&(y1==y)){ getcommand(); return;}
   
     ts++;
     StepXnow++;
     StepYnow++;
     
     if(StepXnow>=StepX)
     {
       StepXnow=0;
       if(x1>x){
         M1Left();
         x++;}
     
       if(x1<x) {
         M1Right();
         x--;
       };
       tmp=1;
     }
    
     if(StepYnow>=StepY)
     {
       StepYnow=0;
       if(y1>y){
         M2Left();
         y++;}
     
       if(y1<y){
         M2Right();
         y--;
       };
       tmp=1;
     }
        if(tmp!=0)ShowKoord();
}
 
void ShowKoord(void)
{
    itoa(x,c); 
    printf("%s ",c); 
    itoa(x1,c); 
    printf("%s ",c); 
    itoa(y,c); 
    printf("%s ",c); 
    itoa(y1,c); 
    printf("%s ",c); 
    putchar(13) ;
}

void getcommand(void)
{
    
    printf("ts =  ");     

    itoa(ts ,c); 
    printf("%s ",c); 
    putchar(13) ;
    printf(" x1,y1 ");     
    scanf("%i %i",&x1,&y1);
    itoa(x1,c); 
    printf("%s ",c); 
    putchar(13) ;     

    itoa(x1,c); 
    printf("%s ",c); 
    itoa(y1,c); 
    printf("%s ",c); 
    itoa(y1,c);  
    putchar(13) ;  
   
    printf("peremeschenie x   "); 
    itoa(x1-x,c); 
    printf("%s ",c); 
    putchar(13) ;    
    
    printf("peremeschenie y   "); 
    itoa(y1-y,c); 
    printf("%s ",c); 
    putchar(13) ;  
       
    tmp=gcdbin((x1-x),(y1-y));
    printf("NOD =  "); 
    itoa(tmp,c); 
    printf("%s ",c); 
    putchar(13) ;
    
    tmp=abs((x1-x)*(y1-y))/tmp;
    
    printf("NOK =  "); 
    itoa(tmp,c); 
    printf("%s ",c); 
    putchar(13);
    
    StepX=tmp/abs(x1-x);   
    
    printf("StepX =  "); 
    itoa(StepX,c); 
    printf("%s ",c); 
    putchar(13);
  
    StepY=tmp/abs(y1-y);    
    printf("StepY =  "); 
    itoa(StepY,c); 
    printf("%s ",c); 
    putchar(13) ;    
    
    StepXnow=0;
    StepYnow=0;
    ts=0;
}              

#define ADC_VREF_TYPE 0x00

// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}


void main(void)
{
PORTA=0x00;
DDRA=0x00;
PORTB=0xFF;
DDRB=0xFF;
PORTC=0x00;
DDRC=0x00;
PORTD=0x00;
DDRD=0xFF;
GICR|=0x40;
MCUCR=0x03;
MCUCSR=0x00;
GIFR=0x40;
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;
ACSR=0x80;
SFIOR=0x00;
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x82; 

x1=read_adc(0)/16;
delay_ms(500);
y1=read_adc(1)/16;
delay_ms(500);

#asm("sei")

while (1)
      {
      // Place your code here
             
      };
}
