#include <mega32.h>
#include <stdio.h>
#include <stdlib.h>
#include "2.h"
#include "8255_motor.h"
#include <delay.h>
#include "gcdbinunit.h"
#include <math.h>

// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
     tmp=0;

     if((x1==x)&(y1==y)){ getcommand(); return;}

     ts++;
     StepXnow++;
     StepYnow++;

     if(StepXnow>=StepX)
     {
       StepXnow=0;
       if(x1>x){
         M1Left();
         x++;}

       if(x1<x) {
         M1Right();
         x--;
       };
       tmp=1;
     }

     if(StepYnow>=StepY)
     {
       StepYnow=0;
       if(y1>y){
         M2Left();
         y++;}

       if(y1<y){
         M2Right();
         y--;
       };
       tmp=1;
     }
        if(tmp!=0)ShowKoord();
}

void ShowKoord(void)
{
    itoa(x,c);
    printf("%s ",c);
    itoa(x1,c);
    printf("%s ",c);
    itoa(y,c);
    printf("%s ",c);
    itoa(y1,c);
    printf("%s ",c);
    putchar(13) ;
}

void getcommand(void)
{

    printf("ts =  ");

    itoa(ts ,c);
    printf("%s ",c);
    putchar(13) ;
    printf(" x1,y1 ");
    scanf("%i %i",&x1,&y1);
    itoa(x1,c);
    printf("%s ",c);
    putchar(13) ;

    itoa(x1,c);
    printf("%s ",c);
    itoa(y1,c);
    printf("%s ",c);
    itoa(y1,c);
    putchar(13) ;

    printf("peremeschenie x   ");
    itoa(x1-x,c);
    printf("%s ",c);
    putchar(13) ;

    printf("peremeschenie y   ");
    itoa(y1-y,c);
    printf("%s ",c);
    putchar(13) ;

    tmp=gcdbin((x1-x),(y1-y));
    printf("NOD =  ");
    itoa(tmp,c);
    printf("%s ",c);
    putchar(13) ;

    tmp=abs((x1-x)*(y1-y))/tmp;

    printf("NOK =  ");
    itoa(tmp,c);
    printf("%s ",c);
    putchar(13);

    StepX=tmp/abs(x1-x);

    printf("StepX =  ");
    itoa(StepX,c);
    printf("%s ",c);
    putchar(13);

    StepY=tmp/abs(y1-y);
    printf("StepY =  ");
    itoa(StepY,c);
    printf("%s ",c);
    putchar(13) ;

    StepXnow=0;
    StepYnow=0;
    ts=0;
}

#define ADC_VREF_TYPE 0x00

// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}


void main(void)
{
PORTA=0x00;
DDRA=0x00;
PORTB=0xFF;
DDRB=0xFF;
PORTC=0x00;
DDRC=0x00;
PORTD=0x00;
DDRD=0xFF;
GICR|=0x40;
MCUCR=0x03;
MCUCSR=0x00;
GIFR=0x40;
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;
ACSR=0x80;
SFIOR=0x00;
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x82;

x1=read_adc(0)/16;
delay_ms(500);
y1=read_adc(1)/16;
delay_ms(500);

#asm("sei")

while (1)
      {
      // Place your code here

      };
}
#define DATA55  PORTB
#define WR55    PORTD.3
#define A055    PORTD.4
#define A155    PORTD.5
#define RESET55 PORTD.6
#define CS55    PORTD.7

#define SETWR55 WR55=1;
#define CLRWR55 WR55=0;
#define SETA055 A055=1;
#define CLRA055 A055=0;
#define SETA155 A155=1;
#define CLRA155 A155=0;
#define SETRS55 RESET55=1;
#define CLRRS55 RESET55=0;
#define SETCS55 CS55=1;
#define CLRCS55 CS55=0;

#define WRP155(A)  CLRRS55 DATA55=A; CLRA055 CLRA155 CLRWR55; CLRCS55;
#define WRP255(A)  CLRRS55 DATA55=A; SETA055 CLRA155 CLRWR55; CLRCS55;
#define WRP355(A)  CLRRS55 DATA55=A; CLRA055 SETA155 CLRWR55; CLRCS55;
#define WRP455(A)  CLRRS55 DATA55=A; SETA055 SETA155 CLRWR55; CLRCS55;

// Povorot M1 vlevo na 7.5gradusov.
void M1Left(void)
{
      switch(M12&0x0F)
        {
          case 0x01: {M12&=0xF0; M12|=0x03;break;}
          case 0x03: {M12&=0xF0; M12|=0x02;break;}
          case 0x02: {M12&=0xF0; M12|=0x06;break;}
          case 0x06: {M12&=0xF0; M12|=0x04;break;}
          case 0x04: {M12&=0xF0; M12|=0x0C;break;}
          case 0x0C: {M12&=0xF0; M12|=0x08;break;}
          case 0x08: {M12&=0xF0; M12|=0x09;break;}
          case 0x09: {M12&=0xF0; M12|=0x01;break;}

          default:   {M12&=0xF0; M12|=0x01;break;}
        }
      WRP155(M12);
      WR55=1;
      CS55=1;
}

// Povorot M1 vpravo na 7.5gradusov.
void M1Right(void)
{
      switch(M12&0x0F)
        {
          case 0x01: {M12&=0xF0; M12|=0x09;break;}
          case 0x03: {M12&=0xF0; M12|=0x01;break;}
          case 0x02: {M12&=0xF0; M12|=0x03;break;}
          case 0x06: {M12&=0xF0; M12|=0x02;break;}
          case 0x04: {M12&=0xF0; M12|=0x06;break;}
          case 0x0C: {M12&=0xF0; M12|=0x04;break;}
          case 0x08: {M12&=0xF0; M12|=0x0C;break;}
          case 0x09: {M12&=0xF0; M12|=0x08;break;}

          default:   {M12&=0xF0; M12|=0x01;break;}
        }
      WRP155(M12);
      WR55=1;
      CS55=1;
}

// Povorot M2 vlevo na 7.5gradusov.
void M2Left(void)
{
      switch(M12&0xF0)
        {
          case 0x10: {M12&=0x0F; M12|=0x30;break;}
          case 0x30: {M12&=0x0F; M12|=0x20;break;}
          case 0x20: {M12&=0x0F; M12|=0x60;break;}
          case 0x60: {M12&=0x0F; M12|=0x40;break;}
          case 0x40: {M12&=0x0F; M12|=0xC0;break;}
          case 0xC0: {M12&=0x0F; M12|=0x80;break;}
          case 0x80: {M12&=0x0F; M12|=0x90;break;}
          case 0x90: {M12&=0x0F; M12|=0x10;break;}

          default:   {M12&=0x0F; M12|=0x10;break;}
        }
      WRP155(M12);
      WR55=1;
      CS55=1;
}

// Povorot M2 vpravo na 7.5gradusov.
void M2Right(void)
{
      switch(M12&0xF0)
        {
          case 0x10: {M12&=0x0F; M12|=0x90;break;}
          case 0x30: {M12&=0x0F; M12|=0x10;break;}
          case 0x20: {M12&=0x0F; M12|=0x30;break;}
          case 0x60: {M12&=0x0F; M12|=0x20;break;}
          case 0x40: {M12&=0x0F; M12|=0x60;break;}
          case 0xC0: {M12&=0x0F; M12|=0x40;break;}
          case 0x80: {M12&=0x0F; M12|=0xC0;break;}
          case 0x90: {M12&=0x0F; M12|=0x80;break;}

          default:   {M12&=0x0F; M12|=0x10;break;}
        }
      WRP155(M12);
      WR55=1;
      CS55=1;
}

// Povorot M3 vlevo na 7.5gradusov.
void M3Left(void)
{
      switch(M34&0x0F)
        {
          case 0x01: {M34&=0xF0; M34|=0x03;break;}
          case 0x03: {M34&=0xF0; M34|=0x02;break;}
          case 0x02: {M34&=0xF0; M34|=0x06;break;}
          case 0x06: {M34&=0xF0; M34|=0x04;break;}
          case 0x04: {M34&=0xF0; M34|=0x0C;break;}
          case 0x0C: {M34&=0xF0; M34|=0x08;break;}
          case 0x08: {M34&=0xF0; M34|=0x09;break;}
          case 0x09: {M34&=0xF0; M34|=0x01;break;}

          default:   {M34&=0xF0; M34|=0x01;break;}
        }
      WRP255(M34);
      WR55=1;
      CS55=1;
}

// Povorot M3 vpravo na 7.5gradusov.
void M3Right(void)
{
      switch(M34&0x0F)
        {
          case 0x01: {M34&=0xF0; M34|=0x09;break;}
          case 0x03: {M34&=0xF0; M34|=0x01;break;}
          case 0x02: {M34&=0xF0; M34|=0x03;break;}
          case 0x06: {M34&=0xF0; M34|=0x02;break;}
          case 0x04: {M34&=0xF0; M34|=0x06;break;}
          case 0x0C: {M34&=0xF0; M34|=0x04;break;}
          case 0x08: {M34&=0xF0; M34|=0x0C;break;}
          case 0x09: {M34&=0xF0; M34|=0x08;break;}

          default:   {M34&=0xF0; M34|=0x01;break;}
        }
      WRP255(M34);
      WR55=1;
      CS55=1;
}

// Povorot M4 vlevo na 7.5gradusov.
void M4Left(void)
{
      switch(M34&0xF0)
        {
          case 0x10: {M34&=0x0F; M34|=0x30;break;}
          case 0x30: {M34&=0x0F; M34|=0x20;break;}
          case 0x20: {M34&=0x0F; M34|=0x60;break;}
          case 0x60: {M34&=0x0F; M34|=0x40;break;}
          case 0x40: {M34&=0x0F; M34|=0xC0;break;}
          case 0xC0: {M34&=0x0F; M34|=0x80;break;}
          case 0x80: {M34&=0x0F; M34|=0x90;break;}
          case 0x90: {M34&=0x0F; M34|=0x10;break;}

          default:   {M34&=0x0F; M34|=0x10;break;}
        }
      WRP255(M34);
      WR55=1;
      CS55=1;
}

// Povorot M4 vpravo na 7.5gradusov.
void M4Right(void)
{
      switch(M34&0xF0)
        {
          case 0x10: {M34&=0x0F; M34|=0x90;break;}
          case 0x30: {M34&=0x0F; M34|=0x10;break;}
          case 0x20: {M34&=0x0F; M34|=0x30;break;}
          case 0x60: {M34&=0x0F; M34|=0x20;break;}
          case 0x40: {M34&=0x0F; M34|=0x60;break;}
          case 0xC0: {M34&=0x0F; M34|=0x40;break;}
          case 0x80: {M34&=0x0F; M34|=0xC0;break;}
          case 0x90: {M34&=0x0F; M34|=0x80;break;}

          default:   {M34&=0x0F; M34|=0x10;break;}
        }
      WRP255(M34);
      WR55=1;
      CS55=1;
}

// Povorot M5 vlevo na 7.5gradusov.
void M5Left(void)
{
      switch(M56&0x0F)
        {
          case 0x01: {M56&=0xF0; M56|=0x03;break;}
          case 0x03: {M56&=0xF0; M56|=0x02;break;}
          case 0x02: {M56&=0xF0; M56|=0x06;break;}
          case 0x06: {M56&=0xF0; M56|=0x04;break;}
          case 0x04: {M56&=0xF0; M56|=0x0C;break;}
          case 0x0C: {M56&=0xF0; M56|=0x08;break;}
          case 0x08: {M56&=0xF0; M56|=0x09;break;}
          case 0x09: {M56&=0xF0; M56|=0x01;break;}

          default:   {M56&=0xF0; M56|=0x01;break;}
        }
      WRP355(M56);
      WR55=1;
      CS55=1;
}

// Povorot M5 vpravo na 7.5gradusov.
void M5Right(void)
{
      switch(M56&0x0F)
        {
          case 0x01: {M56&=0xF0; M56|=0x09;break;}
          case 0x03: {M56&=0xF0; M56|=0x01;break;}
          case 0x02: {M56&=0xF0; M56|=0x03;break;}
          case 0x06: {M56&=0xF0; M56|=0x02;break;}
          case 0x04: {M56&=0xF0; M56|=0x06;break;}
          case 0x0C: {M56&=0xF0; M56|=0x04;break;}
          case 0x08: {M56&=0xF0; M56|=0x0C;break;}
          case 0x09: {M56&=0xF0; M56|=0x08;break;}

          default:   {M56&=0xF0; M56|=0x01;break;}
        }
      WRP355(M56);
      WR55=1;
      CS55=1;
}

// Povorot M6 vlevo na 7.5gradusov.
void M6Left(void)
{
      switch(M56&0xF0)
        {
          case 0x10: {M56&=0x0F; M56|=0x30;break;}
          case 0x30: {M56&=0x0F; M56|=0x20;break;}
          case 0x20: {M56&=0x0F; M56|=0x60;break;}
          case 0x60: {M56&=0x0F; M56|=0x40;break;}
          case 0x40: {M56&=0x0F; M56|=0xC0;break;}
          case 0xC0: {M56&=0x0F; M56|=0x80;break;}
          case 0x80: {M56&=0x0F; M56|=0x90;break;}
          case 0x90: {M56&=0x0F; M56|=0x10;break;}

          default:   {M56&=0x0F; M56|=0x10;break;}
        }
      WRP355(M56);
      WR55=1;
      CS55=1;
}

// Povorot M6 vpravo na 7.5gradusov.
void M6Right(void)
{
      switch(M56&0xF0)
        {
          case 0x10: {M56&=0x0F; M56|=0x90;break;}
          case 0x30: {M56&=0x0F; M56|=0x10;break;}
          case 0x20: {M56&=0x0F; M56|=0x30;break;}
          case 0x60: {M56&=0x0F; M56|=0x20;break;}
          case 0x40: {M56&=0x0F; M56|=0x60;break;}
          case 0xC0: {M56&=0x0F; M56|=0x40;break;}
          case 0x80: {M56&=0x0F; M56|=0xC0;break;}
          case 0x90: {M56&=0x0F; M56|=0x80;break;}

          default:   {M56&=0x0F; M56|=0x10;break;}
        }
      WRP355(M56);
      WR55=1;
      CS55=1;
}

#include "gcdbinunit.h"
#include<math.h>
/*************************************************************************
      
   .
*************************************************************************/
int gcdbin(int a, int b)
{
    int result;
    int r;
    int s;
    int k;

    a = abs(a);
    b = abs(b);
    if( a==0||b==0 )
    {
        result = a+b;
    }
    else
    {
        r = 1;
        s = 1;
        k = 0;
        while(2*(a/2)==a)
        {
            a = a/2;
            r = r*2;
        }
        while(2*(b/2)==b)
        {
            b = b/2;
            s = s*2;
        }
        k = s;
        if( k>r )
        {
            k = r;
        }
        while(a!=b)
        {
            if( a>b )
            {
                a = a-b;
            }
            else
            {
                b = b-a;
                result = b;
                b = a;
                a = result;
            }
            do
            {
                a = a/2;
            }
            while(2*(a/2)==a);
        }
        result = a*k;
    }
    return result;
}



