#define DATA55  PORTB
#define WR55    PORTD.3
#define A055    PORTD.4
#define A155    PORTD.5
#define RESET55 PORTD.6
#define CS55    PORTD.7

#define SETWR55 WR55=1;
#define CLRWR55 WR55=0;
#define SETA055 A055=1;
#define CLRA055 A055=0;
#define SETA155 A155=1;
#define CLRA155 A155=0;
#define SETRS55 RESET55=1;
#define CLRRS55 RESET55=0;
#define SETCS55 CS55=1;
#define CLRCS55 CS55=0;

#define WRP155(A)  CLRRS55 DATA55=A; CLRA055 CLRA155 CLRWR55; CLRCS55;
#define WRP255(A)  CLRRS55 DATA55=A; SETA055 CLRA155 CLRWR55; CLRCS55; 
#define WRP355(A)  CLRRS55 DATA55=A; CLRA055 SETA155 CLRWR55; CLRCS55; 
#define WRP455(A)  CLRRS55 DATA55=A; SETA055 SETA155 CLRWR55; CLRCS55; 

// Povorot M1 vlevo na 7.5gradusov.
void M1Left(void)
{
      switch(M12&0x0F)
        { 
          case 0x01: {M12&=0xF0; M12|=0x03;break;}
          case 0x03: {M12&=0xF0; M12|=0x02;break;}
          case 0x02: {M12&=0xF0; M12|=0x06;break;}
          case 0x06: {M12&=0xF0; M12|=0x04;break;}
          case 0x04: {M12&=0xF0; M12|=0x0C;break;}
          case 0x0C: {M12&=0xF0; M12|=0x08;break;}
          case 0x08: {M12&=0xF0; M12|=0x09;break;}
          case 0x09: {M12&=0xF0; M12|=0x01;break;}        
          
          default:   {M12&=0xF0; M12|=0x01;break;}
        }      
      WRP155(M12); 
      WR55=1;
      CS55=1;
}    

// Povorot M1 vpravo na 7.5gradusov.
void M1Right(void)
{
      switch(M12&0x0F)
        { 
          case 0x01: {M12&=0xF0; M12|=0x09;break;}
          case 0x03: {M12&=0xF0; M12|=0x01;break;}
          case 0x02: {M12&=0xF0; M12|=0x03;break;}
          case 0x06: {M12&=0xF0; M12|=0x02;break;}
          case 0x04: {M12&=0xF0; M12|=0x06;break;}
          case 0x0C: {M12&=0xF0; M12|=0x04;break;}
          case 0x08: {M12&=0xF0; M12|=0x0C;break;}
          case 0x09: {M12&=0xF0; M12|=0x08;break;}        
          
          default:   {M12&=0xF0; M12|=0x01;break;}
        }      
      WRP155(M12); 
      WR55=1;
      CS55=1;
}  

// Povorot M2 vlevo na 7.5gradusov.
void M2Left(void)
{
      switch(M12&0xF0)
        { 
          case 0x10: {M12&=0x0F; M12|=0x30;break;}
          case 0x30: {M12&=0x0F; M12|=0x20;break;}
          case 0x20: {M12&=0x0F; M12|=0x60;break;}
          case 0x60: {M12&=0x0F; M12|=0x40;break;}
          case 0x40: {M12&=0x0F; M12|=0xC0;break;}
          case 0xC0: {M12&=0x0F; M12|=0x80;break;}
          case 0x80: {M12&=0x0F; M12|=0x90;break;}
          case 0x90: {M12&=0x0F; M12|=0x10;break;}        
          
          default:   {M12&=0x0F; M12|=0x10;break;}
        }      
      WRP155(M12); 
      WR55=1;
      CS55=1;
}    

// Povorot M2 vpravo na 7.5gradusov.
void M2Right(void)
{
      switch(M12&0xF0)
        { 
          case 0x10: {M12&=0x0F; M12|=0x90;break;}
          case 0x30: {M12&=0x0F; M12|=0x10;break;}
          case 0x20: {M12&=0x0F; M12|=0x30;break;}
          case 0x60: {M12&=0x0F; M12|=0x20;break;}
          case 0x40: {M12&=0x0F; M12|=0x60;break;}
          case 0xC0: {M12&=0x0F; M12|=0x40;break;}
          case 0x80: {M12&=0x0F; M12|=0xC0;break;}
          case 0x90: {M12&=0x0F; M12|=0x80;break;}        
          
          default:   {M12&=0x0F; M12|=0x10;break;}
        }      
      WRP155(M12); 
      WR55=1;
      CS55=1;
}  

// Povorot M3 vlevo na 7.5gradusov.
void M3Left(void)
{
      switch(M34&0x0F)
        { 
          case 0x01: {M34&=0xF0; M34|=0x03;break;}
          case 0x03: {M34&=0xF0; M34|=0x02;break;}
          case 0x02: {M34&=0xF0; M34|=0x06;break;}
          case 0x06: {M34&=0xF0; M34|=0x04;break;}
          case 0x04: {M34&=0xF0; M34|=0x0C;break;}
          case 0x0C: {M34&=0xF0; M34|=0x08;break;}
          case 0x08: {M34&=0xF0; M34|=0x09;break;}
          case 0x09: {M34&=0xF0; M34|=0x01;break;}        
          
          default:   {M34&=0xF0; M34|=0x01;break;}
        }      
      WRP255(M34); 
      WR55=1;
      CS55=1;
}    

// Povorot M3 vpravo na 7.5gradusov.
void M3Right(void)
{
      switch(M34&0x0F)
        { 
          case 0x01: {M34&=0xF0; M34|=0x09;break;}
          case 0x03: {M34&=0xF0; M34|=0x01;break;}
          case 0x02: {M34&=0xF0; M34|=0x03;break;}
          case 0x06: {M34&=0xF0; M34|=0x02;break;}
          case 0x04: {M34&=0xF0; M34|=0x06;break;}
          case 0x0C: {M34&=0xF0; M34|=0x04;break;}
          case 0x08: {M34&=0xF0; M34|=0x0C;break;}
          case 0x09: {M34&=0xF0; M34|=0x08;break;}        
          
          default:   {M34&=0xF0; M34|=0x01;break;}
        }      
      WRP255(M34); 
      WR55=1;
      CS55=1;
}  

// Povorot M4 vlevo na 7.5gradusov.
void M4Left(void)
{
      switch(M34&0xF0)
        { 
          case 0x10: {M34&=0x0F; M34|=0x30;break;}
          case 0x30: {M34&=0x0F; M34|=0x20;break;}
          case 0x20: {M34&=0x0F; M34|=0x60;break;}
          case 0x60: {M34&=0x0F; M34|=0x40;break;}
          case 0x40: {M34&=0x0F; M34|=0xC0;break;}
          case 0xC0: {M34&=0x0F; M34|=0x80;break;}
          case 0x80: {M34&=0x0F; M34|=0x90;break;}
          case 0x90: {M34&=0x0F; M34|=0x10;break;}        
          
          default:   {M34&=0x0F; M34|=0x10;break;}
        }      
      WRP255(M34); 
      WR55=1;
      CS55=1;
}    

// Povorot M4 vpravo na 7.5gradusov.
void M4Right(void)
{
      switch(M34&0xF0)
        { 
          case 0x10: {M34&=0x0F; M34|=0x90;break;}
          case 0x30: {M34&=0x0F; M34|=0x10;break;}
          case 0x20: {M34&=0x0F; M34|=0x30;break;}
          case 0x60: {M34&=0x0F; M34|=0x20;break;}
          case 0x40: {M34&=0x0F; M34|=0x60;break;}
          case 0xC0: {M34&=0x0F; M34|=0x40;break;}
          case 0x80: {M34&=0x0F; M34|=0xC0;break;}
          case 0x90: {M34&=0x0F; M34|=0x80;break;}        
          
          default:   {M34&=0x0F; M34|=0x10;break;}
        }      
      WRP255(M34); 
      WR55=1;
      CS55=1;
}   

// Povorot M5 vlevo na 7.5gradusov.
void M5Left(void)
{
      switch(M56&0x0F)
        { 
          case 0x01: {M56&=0xF0; M56|=0x03;break;}
          case 0x03: {M56&=0xF0; M56|=0x02;break;}
          case 0x02: {M56&=0xF0; M56|=0x06;break;}
          case 0x06: {M56&=0xF0; M56|=0x04;break;}
          case 0x04: {M56&=0xF0; M56|=0x0C;break;}
          case 0x0C: {M56&=0xF0; M56|=0x08;break;}
          case 0x08: {M56&=0xF0; M56|=0x09;break;}
          case 0x09: {M56&=0xF0; M56|=0x01;break;}        
          
          default:   {M56&=0xF0; M56|=0x01;break;}
        }      
      WRP355(M56); 
      WR55=1;
      CS55=1;
}    

// Povorot M5 vpravo na 7.5gradusov.
void M5Right(void)
{
      switch(M56&0x0F)
        { 
          case 0x01: {M56&=0xF0; M56|=0x09;break;}
          case 0x03: {M56&=0xF0; M56|=0x01;break;}
          case 0x02: {M56&=0xF0; M56|=0x03;break;}
          case 0x06: {M56&=0xF0; M56|=0x02;break;}
          case 0x04: {M56&=0xF0; M56|=0x06;break;}
          case 0x0C: {M56&=0xF0; M56|=0x04;break;}
          case 0x08: {M56&=0xF0; M56|=0x0C;break;}
          case 0x09: {M56&=0xF0; M56|=0x08;break;}        
          
          default:   {M56&=0xF0; M56|=0x01;break;}
        }      
      WRP355(M56); 
      WR55=1;
      CS55=1;
}  

// Povorot M6 vlevo na 7.5gradusov.
void M6Left(void)
{
      switch(M56&0xF0)
        { 
          case 0x10: {M56&=0x0F; M56|=0x30;break;}
          case 0x30: {M56&=0x0F; M56|=0x20;break;}
          case 0x20: {M56&=0x0F; M56|=0x60;break;}
          case 0x60: {M56&=0x0F; M56|=0x40;break;}
          case 0x40: {M56&=0x0F; M56|=0xC0;break;}
          case 0xC0: {M56&=0x0F; M56|=0x80;break;}
          case 0x80: {M56&=0x0F; M56|=0x90;break;}
          case 0x90: {M56&=0x0F; M56|=0x10;break;}        
          
          default:   {M56&=0x0F; M56|=0x10;break;}
        }      
      WRP355(M56); 
      WR55=1;
      CS55=1;
}    

// Povorot M6 vpravo na 7.5gradusov.
void M6Right(void)
{
      switch(M56&0xF0)
        { 
          case 0x10: {M56&=0x0F; M56|=0x90;break;}
          case 0x30: {M56&=0x0F; M56|=0x10;break;}
          case 0x20: {M56&=0x0F; M56|=0x30;break;}
          case 0x60: {M56&=0x0F; M56|=0x20;break;}
          case 0x40: {M56&=0x0F; M56|=0x60;break;}
          case 0xC0: {M56&=0x0F; M56|=0x40;break;}
          case 0x80: {M56&=0x0F; M56|=0xC0;break;}
          case 0x90: {M56&=0x0F; M56|=0x80;break;}        
          
          default:   {M56&=0x0F; M56|=0x10;break;}
        }      
      WRP355(M56); 
      WR55=1;
      CS55=1;
}  